! A possible implementation of the primenumbers subroutine 
subroutine primenumbers(upper, res, icnt)
  implicit none
  integer,intent(in) :: upper
  integer,intent(out) :: res(upper), icnt
  integer :: i, j, last

  icnt = 0
  do i = 2, upper
     j = 2
     last = sqrt(real(i)) + 1
     do while ( (j<last) .and. mod(i, j) /= 0 ) 
        j = j + 1
     enddo
     if (j==last) then
       icnt = icnt+1 
       res(icnt) = i
     endif
  enddo     
  return
end subroutine primenumbers
